apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "session-register.fullname" . }}
  labels:
    {{- include "session-register.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "session-register.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "session-register.selectorLabels" . | nindent 8 }}
      annotations:
        rollme: {{ randAlphaNum 5 | quote }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "session-register.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: {{ template "session-register.image" . }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: 8084
              protocol: TCP
          env:
            - name: REDIS_HOST
              value: {{ .Values.config.redisHost | quote }}
            - name: REDIS_DATABASE_NUMBER
              value: {{ .Values.config.redisDatabaseNumber | quote }}
            - name: REDIS_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.config.redisSecretName }}
                  key: redis-password
            - name: REDIS_DSN
              value: redis://:$(REDIS_PASSWORD)@$(REDIS_HOST)/$(REDIS_DATABASE_NUMBER)
            {{- if .Values.config.apiKey }}
            - name: API_KEY
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.config.apiKeySecretName }}
                  key: api-key
            {{- end }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
